Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1)
@@ -1027,692 +713,237 @@
 !--    If required, change the surface humidity/scalar at the start of the 3D
 !--    run
-       IF ( humidity  .AND.  q_surface_initial_change /= 0.0_wp )                                  &
+       IF ( ( moisture .OR. passive_scalar ) .AND. &
+            q_surface_initial_change /= 0.0 )  THEN
           q(nzb,:,:) = q(nzb,:,:) + q_surface_initial_change
-
-       IF ( passive_scalar  .AND.  s_surface_initial_change /= 0.0_wp )                            &
-          s(nzb,:,:) = s(nzb,:,:) + s_surface_initial_change
-
+       ENDIF
+
+!
+!--    Initialize the random number generator (from numerical recipes)
+       CALL random_function_ini
+
+!
+!--    Impose random perturbation on the horizontal velocity field and then
+!--    remove the divergences from the velocity field
+       IF ( create_disturbances )  THEN
+          CALL disturb_field( nzb_u_inner, tend, u, uxrp,    0 )
+          CALL disturb_field( nzb_v_inner, tend, v,    0, vynp )
+          n_sor = nsor_ini
+          CALL pres
+          n_sor = nsor
+       ENDIF
+
+!
+!--    Once again set the perturbation pressure explicitly to zero in order to
+!--    assure that it does not generate any divergences in the first time step.
+!--    At t=0 the velocity field is free of divergence (as constructed above).
+!--    Divergences being created during a time step are not yet known and thus
+!--    cannot be corrected during the time step yet.
+       p = 0.0
 
 !
 !--    Initialize old and new time levels.
-       tpt_m = 0.0_wp; tu_m = 0.0_wp; tv_m = 0.0_wp; tw_m = 0.0_wp
-       pt_p = pt; u_p = u; v_p = v; w_p = w
-
-       IF ( humidity  )  THEN
-          tq_m = 0.0_wp
+       IF ( timestep_scheme(1:5) /= 'runge' )  THEN
+          e_m = e; pt_m = pt; u_m = u; v_m = v; w_m = w; kh_m = kh; km_m = km
+       ELSE
+          te_m = 0.0; tpt_m = 0.0; tu_m = 0.0; tv_m = 0.0; tw_m = 0.0
+       ENDIF
+       e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
+
+       IF ( moisture  .OR.  passive_scalar )  THEN
+          IF ( ASSOCIATED( q_m ) )  q_m = q
+          IF ( timestep_scheme(1:5) == 'runge' )  tq_m = 0.0
           q_p = q
-       ENDIF
-
-       IF ( passive_scalar )  THEN
-          ts_m = 0.0_wp
-          s_p  = s
-       ENDIF
-
-       IF ( debug_output )  THEN
-          CALL debug_message( 'initializing statistics, boundary conditions, etc.', 'end' )
-       ENDIF
-
-    ELSEIF ( TRIM( initializing_actions ) == 'read_restart_data'  .OR.         &
-             TRIM( initializing_actions ) == 'cyclic_fill' )                   &
+          IF ( moisture  .AND.  ASSOCIATED( vpt_m ) )  vpt_m = vpt
+       ENDIF
+
+    ELSEIF ( TRIM( initializing_actions ) == 'read_restart_data' ) &
     THEN
-
-       IF ( debug_output )  THEN
-          CALL debug_message( 'initializing in case of restart / cyclic_fill', 'start' )
-       ENDIF
-!
-!--    Initialize surface elements and its attributes, e.g. heat- and momentumfluxes, roughness,
-!--    scaling parameters. As number of surface elements might be different between runs, e.g. in
-!--    case of cyclic fill, and not all surface elements are read, surface elements need to be
-!--    initialized before.
-!--    Please note, in case of cyclic fill, surfaces should be initialized after restart data is
-!--    read, else, individual settings of surface parameters will be overwritten from data of
-!--    precursor run, hence, init_surfaces is called a second time after reading the restart data.
-       CALL init_surfaces
-!
-!--    When reading data for cyclic fill of 3D prerun data files, read some of the global variables
-!--    from the restart file which are required for initializing the inflow
-       IF ( TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
-
-!
-!--       Blockwise I/O does not work together with MPI-I/O
-          IF ( restart_data_format_input(1:3) == 'mpi' )  THEN
-             CALL rrd_read_parts_of_global
-          ELSE
-             DO  i = 0, io_blocks-1
-                IF ( i == io_group )  THEN
-                   CALL rrd_read_parts_of_global
-                ENDIF
-#if defined( __parallel )
-                CALL MPI_BARRIER( comm2d, ierr )
-#endif
-             ENDDO
-          ENDIF
-
-       ENDIF
-
-!
-!--    Read processor specific binary data from restart file.
-!--    Blockwise I/O does not work together with MPI-I/O
-       IF ( restart_data_format_input(1:3) == 'mpi' )  THEN
-          CALL rrd_local
-       ELSE
-          DO  i = 0, io_blocks-1
-             IF ( i == io_group )  THEN
-                CALL rrd_local
+!
+!--    Read binary data from restart file
+       CALL read_3d_binary
+
+!
+!--    Calculate initial temperature field and other constants used in case
+!--    of a sloping surface
+       IF ( sloping_surface )  CALL init_slope
+
+!
+!--    Initialize new time levels (only done in order to set boundary values
+!--    including ghost points)
+       e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
+       IF ( moisture  .OR.  passive_scalar )  q_p = q
+
+    ELSE
+!
+!--    Actually this part of the programm should not be reached
+       IF ( myid == 0 )  PRINT*,'+++ init_3d_model: unknown initializing ', &
+                                                    'problem'
+       CALL local_stop
+    ENDIF
+
+!
+!-- If required, initialize dvrp-software
+!    WRITE ( 9, * ) '*** myid=', myid, ' vor init_dvrp'
+!    CALL FLUSH_( 9 )
+    IF ( dt_dvrp /= 9999999.9 )  CALL init_dvrp
+!    WRITE ( 9, * ) '*** myid=', myid, ' nach init_dvrp'
+!    CALL FLUSH_( 9 )
+
+!
+!-- If required, initialize quantities for handling cloud physics
+!-- This routine must be called before init_particles, because
+!-- otherwise, array pt_d_t, needed in data_output_dvrp (called by
+!-- init_particles) is not defined.
+    CALL init_cloud_physics
+
+!
+!-- If required, initialize particles
+!    WRITE ( 9, * ) '*** myid=', myid, ' vor init_particles'
+!    CALL FLUSH_( 9 )
+    CALL init_particles
+!    WRITE ( 9, * ) '*** myid=', myid, ' nach init_particles'
+!    CALL FLUSH_( 9 )
+
+!
+!-- Initialize quantities for special advections schemes
+    CALL init_advec
+
+!
+!-- Initialize Rayleigh damping factors
+    rdf = 0.0
+    IF ( rayleigh_damping_factor /= 0.0 )  THEN
+       DO  k = nzb+1, nzt
+          IF ( zu(k) >= rayleigh_damping_height )  THEN
+             rdf(k) = rayleigh_damping_factor * &
+                      ( SIN( pi * 0.5 * ( zu(k) - rayleigh_damping_height )    &
+                                      / ( zu(nzt) - rayleigh_damping_height ) )&
+                      )**2
+          ENDIF
+       ENDDO
+    ENDIF
+
+!
+!-- Initialize diffusivities used within the outflow damping layer in case of
+!-- non-cyclic lateral boundaries. A linear increase is assumed over the first
+!-- half of the width of the damping layer
+    IF ( bc_lr /= 'cyclic' )  THEN
+
+       DO  i = nxl-1, nxr+1
+
+          IF ( outflow_r )  THEN
+
+             IF ( i >= nx - outflow_damping_width )  THEN
+                km_damp_x(i) = km_damp_max * MIN( 1.0,                    &
+                               ( i - ( nx - outflow_damping_width ) ) / &
+                               REAL( outflow_damping_width/2 )            &
+                                                )
+             ELSE
+                km_damp_x(i) = 0.0
              ENDIF
-#if defined( __parallel )
-             CALL MPI_BARRIER( comm2d, ierr )
-#endif
-          ENDDO
-       ENDIF
-
-
-       IF ( TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
-
-!
-!--       In case of cyclic fill, call init_surfaces a second time, so that surface properties such
-!--       as heat fluxes are initialized as prescribed.
-          CALL init_surfaces
-
-!
-!--       Overwrite u_init, v_init, pt_init, q_init and s_init with the horizontally mean (hom)
-!--       vertical profiles from the end of the prerun, because these profiles shall be used as the
-!--       reference state for the rayleigh damping and the pt_damping. This is especially important
-!--       for the use of large_scale_subsidence, because the reference temperature in the free
-!--       atmosphere changes in time.
-          u_init(:) = hom_sum(:,1,0)
-          v_init(:) = hom_sum(:,2,0)
-          pt_init(:) = hom_sum(:,4,0)
-          IF ( humidity )  q_init(:) = hom_sum(:,41,0)
-          IF ( passive_scalar )  s_init(:) = hom_sum(:,115,0)
-       ENDIF
-!
-!--    In case of complex terrain and cyclic fill method as initialization, shift initial data in
-!--    the vertical direction for each point in the x-y-plane depending on local surface height.
-       IF ( complex_terrain  .AND.  TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                nz_u_shift = topo_top_ind(j,i,1)
-                nz_v_shift = topo_top_ind(j,i,2)
-                nz_w_shift = topo_top_ind(j,i,3)
-                nz_s_shift = topo_top_ind(j,i,0)
-
-                u(nz_u_shift:nzt+1,j,i)  = u(0:nzt+1-nz_u_shift,j,i)
-
-                v(nz_v_shift:nzt+1,j,i)  = v(0:nzt+1-nz_v_shift,j,i)
-
-                w(nz_w_shift:nzt+1,j,i)  = w(0:nzt+1-nz_w_shift,j,i)
-
-                p(nz_s_shift:nzt+1,j,i)  =  p(0:nzt+1-nz_s_shift,j,i)
-                pt(nz_s_shift:nzt+1,j,i) = pt(0:nzt+1-nz_s_shift,j,i)
-             ENDDO
-          ENDDO
-       ENDIF
-!
-!--    Initialization of the turbulence recycling method
-       IF ( TRIM( initializing_actions ) == 'cyclic_fill'  .AND.  turbulent_inflow )  THEN
-!
-!--       First store the profiles to be used at the inflow.
-!--       These profiles are the (temporally) and horizontally averaged vertical profiles from the
-!--       prerun. Alternatively, prescribed profiles for u,v-components can be used.
-          ALLOCATE( mean_inflow_profiles(nzb:nzt+1,1:num_mean_inflow_profiles) )
-
-          IF ( use_prescribed_profile_data )  THEN
-             mean_inflow_profiles(:,1) = u_init            ! u
-             mean_inflow_profiles(:,2) = v_init            ! v
-          ELSE
-             mean_inflow_profiles(:,1) = hom_sum(:,1,0)    ! u
-             mean_inflow_profiles(:,2) = hom_sum(:,2,0)    ! v
-          ENDIF
-          mean_inflow_profiles(:,4) = hom_sum(:,4,0)       ! pt
-          IF ( humidity )  mean_inflow_profiles(:,6) = hom_sum(:,41,0)          ! q
-          IF ( passive_scalar )  mean_inflow_profiles(:,7) = hom_sum(:,115,0)   ! s
-
-!
-!--       In case of complex terrain, determine vertical displacement at inflow boundary and adjust
-!--       mean inflow profiles
-          IF ( complex_terrain )  THEN
-             IF ( nxlg <= 0  .AND.  nxrg >= 0  .AND.  nysg <= 0  .AND.  nyng >= 0 )  THEN
-                nz_u_shift_l = topo_top_ind(j,i,1)
-                nz_v_shift_l = topo_top_ind(j,i,2)
-                nz_w_shift_l = topo_top_ind(j,i,3)
-                nz_s_shift_l = topo_top_ind(j,i,0)
+
+          ELSEIF ( outflow_l )  THEN
+
+             IF ( i <= outflow_damping_width )  THEN
+                km_damp_x(i) = km_damp_max * MIN( 1.0,                    &
+                               ( outflow_damping_width - i ) / &
+                               REAL( outflow_damping_width/2 )            &
+                                                )
              ELSE
-                nz_u_shift_l = 0
-                nz_v_shift_l = 0
-                nz_w_shift_l = 0
-                nz_s_shift_l = 0
+                km_damp_x(i) = 0.0
              ENDIF
 
-#if defined( __parallel )
-             CALL MPI_ALLREDUCE( nz_u_shift_l, nz_u_shift, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
-             CALL MPI_ALLREDUCE( nz_v_shift_l, nz_v_shift, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
-             CALL MPI_ALLREDUCE( nz_w_shift_l, nz_w_shift, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
-             CALL MPI_ALLREDUCE( nz_s_shift_l, nz_s_shift, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
-#else
-             nz_u_shift = nz_u_shift_l
-             nz_v_shift = nz_v_shift_l
-             nz_w_shift = nz_w_shift_l
-             nz_s_shift = nz_s_shift_l
-#endif
-
-             mean_inflow_profiles(:,1) = 0.0_wp
-             mean_inflow_profiles(nz_u_shift:nzt+1,1) = hom_sum(0:nzt+1-nz_u_shift,1,0)  ! u
-
-             mean_inflow_profiles(:,2) = 0.0_wp
-             mean_inflow_profiles(nz_v_shift:nzt+1,2) = hom_sum(0:nzt+1-nz_v_shift,2,0)  ! v
-
-             mean_inflow_profiles(nz_s_shift:nzt+1,4) = hom_sum(0:nzt+1-nz_s_shift,4,0)  ! pt
-
-          ENDIF
-
-!
-!--       If necessary, adjust the horizontal flow field to the prescribed profiles
-          IF ( use_prescribed_profile_data )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      u(k,j,i) = u(k,j,i) - hom_sum(k,1,0) + u_init(k)
-                      v(k,j,i) = v(k,j,i) - hom_sum(k,2,0) + v_init(k)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-!
-!--       Use these mean profiles at the inflow (provided that Dirichlet conditions are used)
-          IF ( bc_dirichlet_l )  THEN
-             DO  j = nysg, nyng
-                DO  k = nzb, nzt+1
-                   u(k,j,nxlg:-1)  = mean_inflow_profiles(k,1)
-                   v(k,j,nxlg:-1)  = mean_inflow_profiles(k,2)
-                   w(k,j,nxlg:-1)  = 0.0_wp
-                   pt(k,j,nxlg:-1) = mean_inflow_profiles(k,4)
-                   IF ( humidity )  q(k,j,nxlg:-1)  = mean_inflow_profiles(k,6)
-                   IF ( passive_scalar )  s(k,j,nxlg:-1)  = mean_inflow_profiles(k,7)
-                ENDDO
-             ENDDO
-          ENDIF
-
-!
-!--       Calculate the damping factors to be used at the inflow. For a turbulent inflow the
-!--       turbulent fluctuations have to be limited vertically because otherwise the turbulent
-!--       inflow layer will grow in time.
-          IF ( inflow_damping_height == 9999999.9_wp )  THEN
-!
-!--          Default: use the inversion height calculated by the prerun; if this is zero,
-!--          inflow_damping_height must be explicitly specified.
-             IF ( hom_sum(nzb+6,pr_palm,0) /= 0.0_wp )  THEN
-                inflow_damping_height = hom_sum(nzb+6,pr_palm,0)
+          ENDIF
+
+       ENDDO
+    ENDIF
+
+    IF ( bc_ns /= 'cyclic' )  THEN
+
+       DO  j = nys-1, nyn+1
+
+          IF ( outflow_n )  THEN
+
+             IF ( j >= ny - outflow_damping_width )  THEN
+                km_damp_y(j) = km_damp_max * MIN( 1.0,                    &
+                               ( j - ( ny - outflow_damping_width ) ) / &
+                               REAL( outflow_damping_width/2 )            &
+                                                )
              ELSE
-                WRITE( message_string, * ) 'inflow_damping_height must be ',                       &
-                                           'explicitly specified because&the inversion height ',   &
-                                           'calculated by the prerun is zero.'
-                CALL message( 'init_3d_model', 'PA0318', 1, 2, 0, 6, 0 )
+                km_damp_y(j) = 0.0
              ENDIF
 
-          ENDIF
-
-          IF ( inflow_damping_width == 9999999.9_wp )  THEN
-!
-!--          Default for the transition range: one tenth of the undamped layer
-             inflow_damping_width = 0.1_wp * inflow_damping_height
-
-          ENDIF
-
-          ALLOCATE( inflow_damping_factor(nzb:nzt+1) )
-
-          DO  k = nzb, nzt+1
-
-             IF ( zu(k) <= inflow_damping_height )  THEN
-                inflow_damping_factor(k) = 1.0_wp
-             ELSEIF ( zu(k) <= ( inflow_damping_height + inflow_damping_width ) )  THEN
-                inflow_damping_factor(k) = 1.0_wp -                                                &
-                                           ( zu(k) - inflow_damping_height ) / inflow_damping_width
+          ELSEIF ( outflow_s )  THEN
+
+             IF ( j <= outflow_damping_width )  THEN
+                km_damp_y(j) = km_damp_max * MIN( 1.0,                    &
+                               ( outflow_damping_width - j ) / &
+                               REAL( outflow_damping_width/2 )            &
+                                                )
              ELSE
-                inflow_damping_factor(k) = 0.0_wp
+                km_damp_y(j) = 0.0
              ENDIF
 
-          ENDDO
-
-       ENDIF
-
-!
-!--    Inside buildings set velocities back to zero
-       IF ( TRIM( initializing_actions ) == 'cyclic_fill'  .AND.  topography /= 'flat' )  THEN
-!
-!--       Inside buildings set velocities back to zero.
-!--       Other scalars (pt, q, s, p, sa, ...) are ignored at present,
-!--       maybe revise later.
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                DO  k = nzb, nzt
-                   u(k,j,i) = MERGE( u(k,j,i), 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 1 ) )
-                   v(k,j,i) = MERGE( v(k,j,i), 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 2 ) )
-                   w(k,j,i) = MERGE( w(k,j,i), 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 3 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-
-       ENDIF
-
-!
-!--    Calculate initial temperature field and other constants used in case of a sloping surface
-       IF ( sloping_surface )  CALL init_slope
-
-!
-!--    Initialize new time levels (only done in order to set boundary values including ghost points)
-       pt_p = pt; u_p = u; v_p = v; w_p = w
-       IF ( humidity )  THEN
-          q_p = q
-       ENDIF
-       IF ( passive_scalar )  s_p  = s
-!
-!--    Allthough tendency arrays are set in prognostic_equations, they have have to be predefined
-!--    here because they are used (but multiplied with 0) there before they are set.
-       tpt_m = 0.0_wp; tu_m = 0.0_wp; tv_m = 0.0_wp; tw_m = 0.0_wp
-       IF ( humidity )  THEN
-          tq_m = 0.0_wp
-       ENDIF
-       IF ( passive_scalar )  ts_m  = 0.0_wp
-
-       IF ( debug_output )  THEN
-          CALL debug_message( 'initializing in case of restart / cyclic_fill', 'end' )
-       ENDIF
-
-    ELSE
-!
-!--    Actually this part of the programm should not be reached
-       message_string = 'unknown initializing problem'
-       CALL message( 'init_3d_model', 'PA0193', 1, 2, 0, 6, 0 )
+          ENDIF
+
+       ENDDO
     ENDIF
 
 !
-!-- Calculate the initial volume flow at the right and north boundary
-    IF ( conserve_volume_flow )  THEN
-
-       IF ( use_prescribed_profile_data )  THEN
-
-          volume_flow_initial_l = 0.0_wp
-          volume_flow_area_l    = 0.0_wp
-
-          IF ( nxr == nx )  THEN
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-                   volume_flow_initial_l(1) = volume_flow_initial_l(1) +                           &
-                                              u_init(k) * dzw(k)                                   &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,j,nxr), 1 )     &
-                                                     )
-
-                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)                       &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,j,nxr), 1 )     &
-                                                     )
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( nyn == ny )  THEN
-             DO  i = nxl, nxr
-                DO  k = nzb+1, nzt
-                   volume_flow_initial_l(2) = volume_flow_initial_l(2) +                           &
-                                              v_init(k) * dzw(k)                                   &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,nyn,i), 2 )     &
-                                                     )
-                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)                       &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,nyn,i), 2 )     &
-                                                     )
-                ENDDO
-             ENDDO
-          ENDIF
-
-#if defined( __parallel )
-          CALL MPI_ALLREDUCE( volume_flow_initial_l(1), volume_flow_initial(1), 2, MPI_REAL,       &
-                              MPI_SUM, comm2d, ierr )
-          CALL MPI_ALLREDUCE( volume_flow_area_l(1), volume_flow_area(1), 2, MPI_REAL, MPI_SUM,    &
-                              comm2d, ierr )
-
-#else
-          volume_flow_initial = volume_flow_initial_l
-          volume_flow_area    = volume_flow_area_l
-#endif
-
-       ELSEIF ( TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
-
-          volume_flow_initial_l = 0.0_wp
-          volume_flow_area_l    = 0.0_wp
-
-          IF ( nxr == nx )  THEN
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-                   volume_flow_initial_l(1) = volume_flow_initial_l(1) +                           &
-                                              hom_sum(k,1,0) * dzw(k)                              &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,j,nx), 1 )      &
-                                                     )
-                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)                       &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,j,nx), 1 )      &
-                                                     )
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( nyn == ny )  THEN
-             DO  i = nxl, nxr
-                DO  k = nzb+1, nzt
-                   volume_flow_initial_l(2) = volume_flow_initial_l(2) +                           &
-                                              hom_sum(k,2,0) * dzw(k)                              &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,ny,i), 2 )      &
-                                                     )
-                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)                       &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,ny,i), 2 )      &
-                                                     )
-                ENDDO
-             ENDDO
-          ENDIF
-
-#if defined( __parallel )
-          CALL MPI_ALLREDUCE( volume_flow_initial_l(1), volume_flow_initial(1), 2, MPI_REAL,       &
-                              MPI_SUM, comm2d, ierr )
-          CALL MPI_ALLREDUCE( volume_flow_area_l(1), volume_flow_area(1), 2, MPI_REAL, MPI_SUM,    &
-                              comm2d, ierr )
-
-#else
-          volume_flow_initial = volume_flow_initial_l
-          volume_flow_area    = volume_flow_area_l
-#endif
-
-       ELSEIF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-
-          volume_flow_initial_l = 0.0_wp
-          volume_flow_area_l    = 0.0_wp
-
-          IF ( nxr == nx )  THEN
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-                   volume_flow_initial_l(1) = volume_flow_initial_l(1) +                           &
-                                              u(k,j,nx) * dzw(k)                                   &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,j,nx), 1 )      &
-                                                     )
-                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)                       &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                   BTEST( wall_flags_total_0(k,j,nx), 1 )          &
-                                                     )
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( nyn == ny )  THEN
-             DO  i = nxl, nxr
-                DO  k = nzb+1, nzt
-                   volume_flow_initial_l(2) = volume_flow_initial_l(2) +                           &
-                                              v(k,ny,i) * dzw(k)                                   &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,ny,i), 2 )      &
-                                                     )
-                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)                       &
-                                              * MERGE( 1.0_wp, 0.0_wp,                             &
-                                                       BTEST( wall_flags_total_0(k,ny,i), 2 )      &
-                                                     )
-                ENDDO
-             ENDDO
-          ENDIF
-
-#if defined( __parallel )
-          CALL MPI_ALLREDUCE( volume_flow_initial_l(1), volume_flow_initial(1), 2, MPI_REAL,       &
-                              MPI_SUM, comm2d, ierr )
-          CALL MPI_ALLREDUCE( volume_flow_area_l(1), volume_flow_area(1), 2, MPI_REAL, MPI_SUM,    &
-                              comm2d, ierr )
-
-#else
-          volume_flow_initial = volume_flow_initial_l
-          volume_flow_area    = volume_flow_area_l
-#endif
-
-       ENDIF
-
-!
-!--    In case of 'bulk_velocity' mode, volume_flow_initial is calculated from u|v_bulk instead
-       IF ( TRIM( conserve_volume_flow_mode ) == 'bulk_velocity' )  THEN
-          volume_flow_initial(1) = u_bulk * volume_flow_area(1)
-          volume_flow_initial(2) = v_bulk * volume_flow_area(2)
-       ENDIF
-
-    ENDIF
-!
-!-- In the following, surface properties can be further initialized with input from static driver
-!-- file.
-!-- At the moment this affects only default surfaces. For example, roughness length or sensible /
-!-- latent heat fluxes can be initialized heterogeneously for default surfaces. Therefore, a generic
-!-- routine from netcdf_data_input_mod is called to read a 2D array.
-    IF ( input_pids_static )  THEN
-!
-!--    Allocate memory for possible static input
-       ALLOCATE( tmp_2d%var(nys:nyn,nxl:nxr) )
-       tmp_2d%var = 0.0_wp
-!
-!--    Open the static input file
-#if defined( __netcdf )
-       CALL open_read_file( TRIM( input_file_static ) //                                           &
-                            TRIM( coupling_char ), pids_id )
-
-       CALL inquire_num_variables( pids_id, num_var_pids )
-!
-!--    Allocate memory to store variable names and read them
-       ALLOCATE( vars_pids(1:num_var_pids) )
-       CALL inquire_variable_names( pids_id, vars_pids )
-!
-!--    Input roughness length.
-       IF ( check_existence( vars_pids, 'z0' ) )  THEN
-!
-!--       Read _FillValue attribute
-          CALL get_attribute( pids_id, char_fill, tmp_2d%fill, .FALSE., 'z0' )
-!
-!--       Read variable
-          CALL get_variable( pids_id, 'z0', tmp_2d%var, nxl, nxr, nys, nyn )
-          CALL add_ghost_layers( tmp_2d%var )
-          CALL exchange_horiz_2d( tmp_2d%var )
-!
-!--       Initialize roughness length. Note, z0 will be only initialized at default-type surfaces.
-!--       At natural or urban z0 is implicitly initialized by the respective parameter lists.
-!--       Initialize horizontal surface elements.
-          CALL init_single_surface_properties( surf_def_h(0)%z0, tmp_2d%var, surf_def_h(0)%ns,     &
-                                               tmp_2d%fill, surf_def_h(0)%i, surf_def_h(0)%j )
-!
-!--       Initialize roughness also at vertical surface elements.
-!--       Note, the actual 2D input arrays are only defined on the subdomain. Therefore, pass the
-!--       index arrays with their respective offset values.
-          DO  l = 0, 3
-             CALL init_single_surface_properties( surf_def_v(l)%z0, tmp_2d%var, surf_def_v(l)%ns,  &
-                                                  tmp_2d%fill, surf_def_v(l)%i+surf_def_v(l)%ioff, &
-                                                  surf_def_v(l)%j+surf_def_v(l)%joff )
-          ENDDO
-
-       ENDIF
-!
-!--    Input surface sensible heat flux.
-       IF ( check_existence( vars_pids, 'shf' ) )  THEN
-!
-!--       Read _FillValue attribute
-          CALL get_attribute( pids_id, char_fill, tmp_2d%fill, .FALSE., 'shf' )
-!
-!--       Read variable
-          CALL get_variable( pids_id, 'shf', tmp_2d%var, nxl, nxr, nys, nyn )
-          CALL add_ghost_layers( tmp_2d%var )
-          CALL exchange_horiz_2d( tmp_2d%var )
-!
-!--       Initialize heat flux. Note, shf will be only initialized at default-type surfaces. At
-!--       natural or urban shf is implicitly initialized by the respective parameter lists.
-!--       Initialize horizontal surface elements.
-          CALL init_single_surface_properties( surf_def_h(0)%shf, tmp_2d%var, surf_def_h(0)%ns,    &
-                                               tmp_2d%fill, surf_def_h(0)%i, surf_def_h(0)%j )
-!
-!--       Initialize heat flux also at vertical surface elements.
-!--       Note, the actual 2D input arrays are only defined on the subdomain. Therefore, pass the
-!--       index arrays with their respective offset values.
-          DO  l = 0, 3
-             CALL init_single_surface_properties( surf_def_v(l)%shf, tmp_2d%var, surf_def_v(l)%ns, &
-                                                  tmp_2d%fill, surf_def_v(l)%i+surf_def_v(l)%ioff, &
-                                                  surf_def_v(l)%j+surf_def_v(l)%joff )
-          ENDDO
-
-       ENDIF
-!
-!--    Input surface latent heat flux.
-       IF ( humidity )  THEN
-          IF ( check_existence( vars_pids, 'qsws' ) )  THEN
-!
-!--          Read _FillValue attribute
-             CALL get_attribute( pids_id, char_fill, tmp_2d%fill, .FALSE., 'qsws' )
-!
-!--          Read variable
-             CALL get_variable( pids_id, 'qsws', tmp_2d%var, nxl, nxr, nys, nyn )
-             CALL add_ghost_layers( tmp_2d%var )
-             CALL exchange_horiz_2d( tmp_2d%var )
-!
-!--          Initialize latent heat flux. Note, qsws will be only initialized at default-type surfaces.
-!--          At natural or urban qsws is implicitly initialized by the respective parameter lists.
-!--          Initialize horizontal surface elements.
-             CALL init_single_surface_properties( surf_def_h(0)%qsws, tmp_2d%var, surf_def_h(0)%ns,&
-                                                  tmp_2d%fill, surf_def_h(0)%i, surf_def_h(0)%j )
-!
-!--          Initialize latent heat flux also at vertical surface elements.
-!--          Note, the actual 2D input arrays are only defined on the subdomain. Therefore, pass the
-!--          index arrays with their respective offset values.
-             DO  l = 0, 3
-                CALL init_single_surface_properties( surf_def_v(l)%qsws, tmp_2d%var,               &
-                                                     surf_def_v(l)%ns, tmp_2d%fill,                &
-                                                     surf_def_v(l)%i+surf_def_v(l)%ioff,           &
-                                                     surf_def_v(l)%j+surf_def_v(l)%joff )
-             ENDDO
-
-          ENDIF
-       ENDIF
-!
-!--    Input passive scalar flux.
-       IF ( passive_scalar )  THEN
-          IF ( check_existence( vars_pids, 'ssws' ) )  THEN
-!
-!--          Read _FillValue attribute
-             CALL get_attribute( pids_id, char_fill, tmp_2d%fill, .FALSE., 'ssws' )
-!
-!--          Read variable
-             CALL get_variable( pids_id, 'ssws', tmp_2d%var, nxl, nxr, nys, nyn )
-             CALL add_ghost_layers( tmp_2d%var )
-             CALL exchange_horiz_2d( tmp_2d%var )
-!
-!--          Initialize passive scalar flux. Initialize horizontal surface elements.
-             CALL init_single_surface_properties( surf_def_h(0)%ssws, tmp_2d%var, surf_def_h(0)%ns,&
-                                                  tmp_2d%fill, surf_def_h(0)%i, surf_def_h(0)%j )
-
-             DO  l = 0, 3
-                CALL init_single_surface_properties( surf_def_v(l)%ssws, tmp_2d%var,               &
-                                                     surf_def_v(l)%ns, tmp_2d%fill,                &
-                                                     surf_def_v(l)%i+surf_def_v(l)%ioff,           &
-                                                     surf_def_v(l)%j+surf_def_v(l)%joff )
-             ENDDO
-
-          ENDIF
-       ENDIF
-!
-!--    Additional variables, can be initialized the
-!--    same way.
-
-!
-!--    Finally, close the input file and deallocate temporary arrays
-       DEALLOCATE( vars_pids )
-
-       CALL close_input_file( pids_id )
-#endif
-       DEALLOCATE( tmp_2d%var )
-    ENDIF
-!
-!-- Finally, if random_heatflux is set, disturb shf at horizontal surfaces. Actually, this should be
-!-- done in surface_mod, where all other initializations of surface quantities are done. However,
-!-- this would create a ring dependency, hence, it is done here. Maybe delete disturb_heatflux and
-!-- tranfer the respective code directly into the initialization in surface_mod.
-    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.                                &
-         TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
-
-       IF ( use_surface_fluxes  .AND.  constant_heatflux  .AND.  random_heatflux )  THEN
-          IF ( surf_def_h(0)%ns >= 1 )  CALL disturb_heatflux( surf_def_h(0) )
-          IF ( surf_lsm_h(0)%ns >= 1 )  CALL disturb_heatflux( surf_lsm_h(0) )
-          IF ( surf_usm_h(0)%ns >= 1 )  CALL disturb_heatflux( surf_usm_h(0) )
-       ENDIF
-    ENDIF
-
-!
-!-- Compute total sum of grid points and the mean surface level height for each statistic region.
-!-- These are mainly used for horizontal averaging of turbulence statistics.
-!-- ngp_2dh: number of grid points of a horizontal cross section through the respective statistic
-!--          region
-!-- ngp_3d:  number of grid points of the respective statistic region
-    ngp_2dh_outer_l   = 0
-    ngp_2dh_outer     = 0
-    ngp_2dh_s_inner_l = 0
-    ngp_2dh_s_inner   = 0
-    ngp_2dh_l         = 0
-    ngp_2dh           = 0
-    ngp_3d_inner_l    = 0.0_wp
-    ngp_3d_inner      = 0
-    ngp_3d            = 0
-    ngp_sums          = ( nz + 2 ) * ( pr_palm + max_pr_user )
-
-    mean_surface_level_height   = 0.0_wp
-    mean_surface_level_height_l = 0.0_wp
-!
-!-- To do: New concept for these non-topography grid points!
+!-- Initialize local summation arrays for UP flow_statistics. This is necessary
+!-- because they may not yet have been initialized when they are called from 
+!-- flow_statistics (or - depending on the chosen model run - are never 
+!-- initialized)
+    sums_divnew_l      = 0.0
+    sums_divold_l      = 0.0
+    sums_l_l           = 0.0
+    sums_up_fraction_l = 0.0
+    sums_wsts_bc_l     = 0.0
+
+!
+!-- Pre-set masks for regional statistics. Default is the total model domain.
+    rmask = 1.0
+
+!
+!-- User-defined initializing actions
+    CALL user_init
+
+!
+!-- Input binary data file is not needed anymore. This line must be placed
+!-- after call of user_init!
+    CALL close_file( 13 )
+
+!
+!-- Compute total sum of active mask grid points
+!-- ngp_2dh: number of grid points of a horizontal cross section through the
+!--          total domain
+!-- ngp_3d:  number of grid points of the total domain
+!-- Note: The lower vertical index nzb_s_outer imposes a small error on the 2D 
+!-- ----  averages of staggered variables such as u and v due to the topography
+!--       arrangement on the staggered grid. Maybe revise later.
+    ngp_2dh_outer_l = 0
+    ngp_2dh_outer   = 0
+    ngp_2dh_l       = 0
+    ngp_2dh         = 0
+    ngp_3d_inner_l  = 0
+    ngp_3d_inner    = 0
+    ngp_3d          = 0
+    ngp_sums        = ( nz + 2 ) * var_sum
+
     DO  sr = 0, statistic_regions
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             IF ( rmask(j,i,sr) == 1.0_wp )  THEN
+             IF ( rmask(j,i,sr) == 1.0 )  THEN
 !
 !--             All xy-grid points
                 ngp_2dh_l(sr) = ngp_2dh_l(sr) + 1
 !
-!--             Determine mean surface-level height. In case of downward-facing walls are present,
-!--             more than one surface level exist.
-!--             In this case, use the lowest surface-level height.
-                IF ( surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i) )  THEN
-                   m = surf_def_h(0)%start_index(j,i)
-                   k = surf_def_h(0)%k(m)
-                   mean_surface_level_height_l(sr) = mean_surface_level_height_l(sr) + zw(k-1)
-                ENDIF
-                IF ( surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i) )  THEN
-                   m = surf_lsm_h(0)%start_index(j,i)
-                   k = surf_lsm_h(0)%k(m)
-                   mean_surface_level_height_l(sr) = mean_surface_level_height_l(sr) + zw(k-1)
-                ENDIF
-                IF ( surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i) )  THEN
-                   m = surf_usm_h(0)%start_index(j,i)
-                   k = surf_usm_h(0)%k(m)
-                   mean_surface_level_height_l(sr) = mean_surface_level_height_l(sr) + zw(k-1)
-                ENDIF
-
-                k_surf = k - 1
-
-                DO  k = nzb, nzt+1
-!
-!--                xy-grid points above topography
-                   ngp_2dh_outer_l(k,sr) = ngp_2dh_outer_l(k,sr)     +                             &
-                                           MERGE( 1, 0, BTEST( wall_flags_total_0(k,j,i), 24 ) )
-
-                   ngp_2dh_s_inner_l(k,sr) = ngp_2dh_s_inner_l(k,sr) +                             &
-                                             MERGE( 1, 0, BTEST( wall_flags_total_0(k,j,i), 22 ) )
-
+!--             xy-grid points above topography
+                DO  k = nzb_s_outer(j,i), nz + 1
+                   ngp_2dh_outer_l(k,sr) = ngp_2dh_outer_l(k,sr) + 1
                 ENDDO
 !
 !--             All grid points of the total domain above topography
-                ngp_3d_inner_l(sr) = ngp_3d_inner_l(sr) + ( nz - k_surf + 2 )
-
-
-
+                ngp_3d_inner_l(sr) = ngp_3d_inner_l(sr) + &
+                                     ( nz - nzb_s_inner(j,i) + 2 )
              ENDIF
           ENDDO
